 src/backend/access/transam/xlog.c | 14 ++++++++++++++
 1 file changed, 14 insertions(+)

diff --git a/src/backend/access/transam/xlog.c b/src/backend/access/transam/xlog.c
index 55cac186dc..757b2bf3d0 100644
--- a/src/backend/access/transam/xlog.c
+++ b/src/backend/access/transam/xlog.c
@@ -11745,10 +11745,24 @@ rm_redo_error_callback(void *arg)
 {
 	XLogReaderState *record = (XLogReaderState *) arg;
 	StringInfoData buf;
+	int block_id;
 
 	initStringInfo(&buf);
 	xlog_outdesc(&buf, record);
 
+	for (block_id = 0; block_id <= record->max_block_id; block_id++)
+	{
+		RelFileNode rnode;
+		ForkNumber forknum;
+		BlockNumber blknum;
+
+		if (XLogRecGetBlockTag(record, block_id, &rnode, &forknum, &blknum))
+			appendStringInfo(&buf,", blkref #%d: rel %u/%u/%u fork %s blk %u",
+						block_id, rnode.spcNode, rnode.dbNode,
+						rnode.relNode, forkNames[forknum],
+						blknum);
+	}
+
 	/* translator: %s is a WAL record description */
 	errcontext("WAL redo at %X/%X for %s",
 			   (uint32) (record->ReadRecPtr >> 32),
